<script setup lang="ts">
import { computed, ref } from 'vue'

interface Todo{
    id: number
    text: string
    done: boolean
}

let id = 0

const num1 = ref(0)
const num2 = ref(0)
// const result = ref(0)
const hideCompleted = ref(false)

const newTodo = ref('')
const todos = ref<Todo[]>([
  { id: id++, text: 'Learn HTML', done: true },
  { id: id++, text: 'Learn JavaScript', done: true },
  { id: id++, text: 'Learn Vue', done: false }
])

function addTodo() {
  todos.value.push({ id: id++, text: newTodo.value, done:false })
  newTodo.value = ''
}

function removeTodo(todo: Todo) {
  todos.value = todos.value.filter((t) => t !== todo)
  // todos.value = todos.value.filter(function (t) {
    // return t.id !== id
  // })
    // const index = todos.value.findIndex((t) => t.id ===id)
    // todos.value.splice(index,1)
    // const index = todos.value.indexOf(todo)
    // todos.value.splice(index,1)
}

// function Calculate() {
//     result.value = num1.value + num2.value 
// }

const filteredTodos = computed(() => {
    if(hideCompleted.value){
        return todos.value.filter((t) => !t.done)
    } else {
        return todos.value
    }

//   return hideCompleted.value
//     ? todos.value.filter((t) => !t.done)
//     : todos.value
})

const result = computed(() => num1.value + num2.value )
</script>

<template>
    <br>
    <input type="text" v-model.number="num1" /> +<input type="text" v-model.number="num2" /> = {{ result }}
    <!-- <button @click="Calculate()">Calculate</button> <br><br> -->

    <div>{{ todos }}</div>
    <div>{{ newTodo }}</div>
    <!-- <input type="text" v-model="newTodo" />
    <button @click="addTodo">Add Todo</button>    -->
    
    <form @submit.prevent="addTodo">
        <input v-model="newTodo">
        <button>Add Todo</button>
      </form>
  <ul>
    <li v-for="todo in filteredTodos" :key="todo.id" :class="{done: todo.done}">
        <input type="checkbox" v-model="todo.done" />{{ todo.text }} 
        <button @click="removeTodo(todo)">X</button>
    </li>
  </ul>
  <button @click="hideCompleted = !hideCompleted">
    {{ hideCompleted ? 'Show all' : 'Hide completed' }}
  </button>
</template>

<style scoped>
.done {
  text-decoration: line-through;
}
</style>